# -*- coding: utf-8 -*-
#
# File: AwstatsTool.py
#
# Copyright (c) 2007 by []
# Generator: ArchGenXML Version 1.5.3 dev/svn
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """unknown <unknown>"""
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.BlueAwstats.config import *


from Products.CMFCore.utils import UniqueObject

    
##code-section module-header #fill in your manual code here
import os
import types

from zope.interface import implements

from interfaces import IAwstatsProvider
from config import *
##/code-section module-header

schema = Schema((

),
)

##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

AwstatsTool_schema = BaseSchema.copy() + \
    schema.copy()

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class AwstatsTool(UniqueObject, BaseContent):
    """
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(UniqueObject,'__implements__',()),) + (getattr(BaseContent,'__implements__',()),)

    # This name appears in the 'add' box
    archetype_name = 'AwstatsTool'

    meta_type = 'AwstatsTool'
    portal_type = 'AwstatsTool'
    allowed_content_types = []
    filter_content_types = 0
    global_allow = 0
    #content_icon = 'AwstatsTool.gif'
    immediate_view = 'base_view'
    default_view = 'base_view'
    suppl_views = ()
    typeDescription = "AwstatsTool"
    typeDescMsgId = 'description_edit_awstatstool'
    toolicon = 'awstatstool.png'


    actions =  (


       {'action': "string:${object_url}/awstats_view",
        'category': "object",
        'id': 'view',
        'name': 'view',
        'permissions': ("View",),
        'condition': 'python:1'
       },


    )

    _at_rename_after_creation = True

    schema = AwstatsTool_schema

    ##code-section class-header #fill in your manual code here
    implements(IAwstatsProvider)
    ##/code-section class-header


    # tool-constructors have no id argument, the id is fixed
    def __init__(self, id=None):
        BaseContent.__init__(self,'portal_awstatstool')
        self.setTitle('AwstatsTool')
        
        ##code-section constructor-footer #fill in your manual code here
        ##/code-section constructor-footer


    # tool should not appear in portal_catalog
    def at_post_edit_script(self):
        self.unindexObject()
        
        ##code-section post-edit-method-footer #fill in your manual code here
        ##/code-section post-edit-method-footer


    # Methods

    security.declareProtected("View Statistics", 'getStatistics')
    def getStatistics(self, domain):
        """returns the ParsedStatistics for given domain."""
        smt = self._getSmt()
        return smt.getStatistics(domain)

    security.declareProtected("View Statistics", 'reload')
    def reload(self, domain):
        """reload the statistics for given domain or reload all statistics
        if domain is None."""
        smt = self._getSmt()
        smt.purge(domain)

    security.declareProtected("View Statistics", 'statsAvailable')
    def statsAvailable(self):
        """Check if managementtool is available
        """
        smt = self._getSmt()
        if not smt:
            return False
        return True

    security.declareProtected("View Statistics", 'getAllowedDomains')
    def getAllowedDomains(self):
        """Return a list of domains."""
        smt = self._getSmt()
        if not smt:
            return []
        return smt.getAllowedDomains()

    # Manually created methods

    def _getSmt(self):
        try:
            return self.blueawstats_management_tool
        except:
            return None



registerType(AwstatsTool, PROJECTNAME)
# end of class AwstatsTool

##code-section module-footer #fill in your manual code here
##/code-section module-footer



